//
//	$Date: 2000/03/28 11:58:58 $
//	$Revision: 1.3 $
//
//	$B%U%!%$%k$+$i%?%$%H%k$d%m!<%^;z$r<hF@(B
//
#include <stdio.h>
#include "contents.h"
#include "kakasilib.h"	// kakasi$B%i%$%V%i%jMQ(B

char *
roma(char *filename) // $B%U%!%$%k$N@hF,$+$i(B1000$BJ8;zDxEY$N%m!<%^;z$r<hF@(B
{
	static int kakasiinit = 0;
	static char romabuf[1000];
	int romabuflen, len;
	FILE *f;
	char buf[1000];
	char *r;

	if((f = fopen(filename,"r")) == NULL) return "";

	if(! kakasiinit){
		kakasiMode("Ha");
		kakasiMode("Ja");
		kakasiMode("Ka");
		kakasiMode("Ea");
#ifdef SJIS
		kakasiInputCode("sjis");
#else
		kakasiInputCode("euc");
#endif
	}
	strcpy(romabuf,"");
	romabuflen = 0;
	while(fgets(buf,1000,f)){
		r = kakasiConv(buf);
		len = strlen(r);
		if(romabuflen + len >= 1000-1) break;
		strcat(romabuf,r);
		romabuflen += len;
	}
	fclose(f);
	return romabuf;
}

char *
titlestr(char *filename) // $B%U%!%$%k$+$i%?%$%H%k9T$r<hF@(B
{
	FILE *f;
	char buf[1000],dummy[100];
	static char title[1000],line1[1000];

	if((f = fopen(filename,"r")) == NULL) return "";
	title[0] = line1[0] = '\0';
	while(fgets(buf,1000,f)){
		if(line1[0] == '\0'){
			sscanf(buf,"%[^\n]",line1);
		}
#define MATCH(s) (strncmp(buf,s,strlen(s))==0)
		if(MATCH("Subject:") || MATCH("Title:") ||
		MATCH("Name:") || MATCH("Contents:") ||
		MATCH("Organization:") || MATCH("Word:")){
			sscanf(buf,"%s %[^\n]",dummy,title);
			fclose(f);
			return title;
		}
	}
	fclose(f);
	return line1;
}
